# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from or_msgs/OrMatchResult.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import or_msgs.msg
import std_msgs.msg
import sensor_msgs.msg

class OrMatchResult(genpy.Message):
  _md5sum = "2fd40744498bda2c7e53bd65ca153b32"
  _type = "or_msgs/OrMatchResult"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """sensor_msgs/Image image
KeyPoint[] key_points
MatchResult[] match_results
BoundingBox2D[] bounding_boxes 
int32 seq_num  # this can be removed
sensor_msgs/Image debug_image_with_bb

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in include/sensor_msgs/image_encodings.h

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: or_msgs/KeyPoint
float32 x
float32 y
float32 scale
float32 strength
float32 orientation
int32 sign
float64[] feature_vector
uint32[] vector_limits

================================================================================
MSG: or_msgs/MatchResult
string object_name
string object_type

sensor_msgs/Image image
int32 image_index
string image_name
Point2D[] outline
Point2D[] b_box
Point2D center
int32 bounding_box_index              # this can be removed

uint32[] key_point_index_map           # this can be removed
KeyPoint[] object_key_points

KeyPointMatch[] stage1_matchesb_
KeyPointMatchArray[] stage2_matches
KeyPointMatch[] stage3_matches
KeyPoint[] scene_key_points_within_outline

float64[9] homography

================================================================================
MSG: or_msgs/Point2D
float64 x
float64 y

================================================================================
MSG: or_msgs/KeyPointMatch
uint32 index1
uint32 index2
float64 distance
float64 turn_angle
float64 scale_quotient

================================================================================
MSG: or_msgs/KeyPointMatchArray
KeyPointMatch[] key_point_match_array

================================================================================
MSG: or_msgs/BoundingBox2D
float32 minX
float32 minY
float32 maxX
float32 maxY
"""
  __slots__ = ['image','key_points','match_results','bounding_boxes','seq_num','debug_image_with_bb']
  _slot_types = ['sensor_msgs/Image','or_msgs/KeyPoint[]','or_msgs/MatchResult[]','or_msgs/BoundingBox2D[]','int32','sensor_msgs/Image']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       image,key_points,match_results,bounding_boxes,seq_num,debug_image_with_bb

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(OrMatchResult, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.image is None:
        self.image = sensor_msgs.msg.Image()
      if self.key_points is None:
        self.key_points = []
      if self.match_results is None:
        self.match_results = []
      if self.bounding_boxes is None:
        self.bounding_boxes = []
      if self.seq_num is None:
        self.seq_num = 0
      if self.debug_image_with_bb is None:
        self.debug_image_with_bb = sensor_msgs.msg.Image()
    else:
      self.image = sensor_msgs.msg.Image()
      self.key_points = []
      self.match_results = []
      self.bounding_boxes = []
      self.seq_num = 0
      self.debug_image_with_bb = sensor_msgs.msg.Image()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.image.header.seq, _x.image.header.stamp.secs, _x.image.header.stamp.nsecs))
      _x = self.image.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.image.height, _x.image.width))
      _x = self.image.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.image.is_bigendian, _x.image.step))
      _x = self.image.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.key_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.key_points:
        _x = val1
        buff.write(_struct_5fi.pack(_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign))
        length = len(val1.feature_vector)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.feature_vector))
        length = len(val1.vector_limits)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.pack(pattern, *val1.vector_limits))
      length = len(self.match_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.match_results:
        _x = val1.object_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.object_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v1 = val1.image
        _v2 = _v1.header
        buff.write(_struct_I.pack(_v2.seq))
        _v3 = _v2.stamp
        _x = _v3
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v2.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v1
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v1.encoding
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v1
        buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
        _x = _v1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.image_index))
        _x = val1.image_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.outline)
        buff.write(_struct_I.pack(length))
        for val2 in val1.outline:
          _x = val2
          buff.write(_struct_2d.pack(_x.x, _x.y))
        length = len(val1.b_box)
        buff.write(_struct_I.pack(length))
        for val2 in val1.b_box:
          _x = val2
          buff.write(_struct_2d.pack(_x.x, _x.y))
        _v4 = val1.center
        _x = _v4
        buff.write(_struct_2d.pack(_x.x, _x.y))
        buff.write(_struct_i.pack(val1.bounding_box_index))
        length = len(val1.key_point_index_map)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.pack(pattern, *val1.key_point_index_map))
        length = len(val1.object_key_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.object_key_points:
          _x = val2
          buff.write(_struct_5fi.pack(_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign))
          length = len(val2.feature_vector)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val2.feature_vector))
          length = len(val2.vector_limits)
          buff.write(_struct_I.pack(length))
          pattern = '<%sI'%length
          buff.write(struct.pack(pattern, *val2.vector_limits))
        length = len(val1.stage1_matchesb_)
        buff.write(_struct_I.pack(length))
        for val2 in val1.stage1_matchesb_:
          _x = val2
          buff.write(_struct_2I3d.pack(_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient))
        length = len(val1.stage2_matches)
        buff.write(_struct_I.pack(length))
        for val2 in val1.stage2_matches:
          length = len(val2.key_point_match_array)
          buff.write(_struct_I.pack(length))
          for val3 in val2.key_point_match_array:
            _x = val3
            buff.write(_struct_2I3d.pack(_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient))
        length = len(val1.stage3_matches)
        buff.write(_struct_I.pack(length))
        for val2 in val1.stage3_matches:
          _x = val2
          buff.write(_struct_2I3d.pack(_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient))
        length = len(val1.scene_key_points_within_outline)
        buff.write(_struct_I.pack(length))
        for val2 in val1.scene_key_points_within_outline:
          _x = val2
          buff.write(_struct_5fi.pack(_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign))
          length = len(val2.feature_vector)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val2.feature_vector))
          length = len(val2.vector_limits)
          buff.write(_struct_I.pack(length))
          pattern = '<%sI'%length
          buff.write(struct.pack(pattern, *val2.vector_limits))
        buff.write(_struct_9d.pack(*val1.homography))
      length = len(self.bounding_boxes)
      buff.write(_struct_I.pack(length))
      for val1 in self.bounding_boxes:
        _x = val1
        buff.write(_struct_4f.pack(_x.minX, _x.minY, _x.maxX, _x.maxY))
      _x = self
      buff.write(_struct_i3I.pack(_x.seq_num, _x.debug_image_with_bb.header.seq, _x.debug_image_with_bb.header.stamp.secs, _x.debug_image_with_bb.header.stamp.nsecs))
      _x = self.debug_image_with_bb.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.debug_image_with_bb.height, _x.debug_image_with_bb.width))
      _x = self.debug_image_with_bb.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.debug_image_with_bb.is_bigendian, _x.debug_image_with_bb.step))
      _x = self.debug_image_with_bb.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.image is None:
        self.image = sensor_msgs.msg.Image()
      if self.key_points is None:
        self.key_points = None
      if self.match_results is None:
        self.match_results = None
      if self.bounding_boxes is None:
        self.bounding_boxes = None
      if self.debug_image_with_bb is None:
        self.debug_image_with_bb = sensor_msgs.msg.Image()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.image.header.seq, _x.image.header.stamp.secs, _x.image.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.image.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.image.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.image.height, _x.image.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.image.encoding = str[start:end].decode('utf-8')
      else:
        self.image.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.image.is_bigendian, _x.image.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.image.data = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.key_points = []
      for i in range(0, length):
        val1 = or_msgs.msg.KeyPoint()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign,) = _struct_5fi.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.feature_vector = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        val1.vector_limits = struct.unpack(pattern, str[start:end])
        self.key_points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.match_results = []
      for i in range(0, length):
        val1 = or_msgs.msg.MatchResult()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.object_name = str[start:end].decode('utf-8')
        else:
          val1.object_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.object_type = str[start:end].decode('utf-8')
        else:
          val1.object_type = str[start:end]
        _v5 = val1.image
        _v6 = _v5.header
        start = end
        end += 4
        (_v6.seq,) = _struct_I.unpack(str[start:end])
        _v7 = _v6.stamp
        _x = _v7
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v6.frame_id = str[start:end].decode('utf-8')
        else:
          _v6.frame_id = str[start:end]
        _x = _v5
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v5.encoding = str[start:end].decode('utf-8')
        else:
          _v5.encoding = str[start:end]
        _x = _v5
        start = end
        end += 5
        (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v5.data = str[start:end]
        start = end
        end += 4
        (val1.image_index,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.image_name = str[start:end].decode('utf-8')
        else:
          val1.image_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.outline = []
        for i in range(0, length):
          val2 = or_msgs.msg.Point2D()
          _x = val2
          start = end
          end += 16
          (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
          val1.outline.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.b_box = []
        for i in range(0, length):
          val2 = or_msgs.msg.Point2D()
          _x = val2
          start = end
          end += 16
          (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
          val1.b_box.append(val2)
        _v8 = val1.center
        _x = _v8
        start = end
        end += 16
        (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
        start = end
        end += 4
        (val1.bounding_box_index,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        val1.key_point_index_map = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.object_key_points = []
        for i in range(0, length):
          val2 = or_msgs.msg.KeyPoint()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign,) = _struct_5fi.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val2.feature_vector = struct.unpack(pattern, str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sI'%length
          start = end
          end += struct.calcsize(pattern)
          val2.vector_limits = struct.unpack(pattern, str[start:end])
          val1.object_key_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.stage1_matchesb_ = []
        for i in range(0, length):
          val2 = or_msgs.msg.KeyPointMatch()
          _x = val2
          start = end
          end += 32
          (_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient,) = _struct_2I3d.unpack(str[start:end])
          val1.stage1_matchesb_.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.stage2_matches = []
        for i in range(0, length):
          val2 = or_msgs.msg.KeyPointMatchArray()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.key_point_match_array = []
          for i in range(0, length):
            val3 = or_msgs.msg.KeyPointMatch()
            _x = val3
            start = end
            end += 32
            (_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient,) = _struct_2I3d.unpack(str[start:end])
            val2.key_point_match_array.append(val3)
          val1.stage2_matches.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.stage3_matches = []
        for i in range(0, length):
          val2 = or_msgs.msg.KeyPointMatch()
          _x = val2
          start = end
          end += 32
          (_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient,) = _struct_2I3d.unpack(str[start:end])
          val1.stage3_matches.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.scene_key_points_within_outline = []
        for i in range(0, length):
          val2 = or_msgs.msg.KeyPoint()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign,) = _struct_5fi.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val2.feature_vector = struct.unpack(pattern, str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sI'%length
          start = end
          end += struct.calcsize(pattern)
          val2.vector_limits = struct.unpack(pattern, str[start:end])
          val1.scene_key_points_within_outline.append(val2)
        start = end
        end += 72
        val1.homography = _struct_9d.unpack(str[start:end])
        self.match_results.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bounding_boxes = []
      for i in range(0, length):
        val1 = or_msgs.msg.BoundingBox2D()
        _x = val1
        start = end
        end += 16
        (_x.minX, _x.minY, _x.maxX, _x.maxY,) = _struct_4f.unpack(str[start:end])
        self.bounding_boxes.append(val1)
      _x = self
      start = end
      end += 16
      (_x.seq_num, _x.debug_image_with_bb.header.seq, _x.debug_image_with_bb.header.stamp.secs, _x.debug_image_with_bb.header.stamp.nsecs,) = _struct_i3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.debug_image_with_bb.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.debug_image_with_bb.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.debug_image_with_bb.height, _x.debug_image_with_bb.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.debug_image_with_bb.encoding = str[start:end].decode('utf-8')
      else:
        self.debug_image_with_bb.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.debug_image_with_bb.is_bigendian, _x.debug_image_with_bb.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.debug_image_with_bb.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.image.header.seq, _x.image.header.stamp.secs, _x.image.header.stamp.nsecs))
      _x = self.image.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.image.height, _x.image.width))
      _x = self.image.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.image.is_bigendian, _x.image.step))
      _x = self.image.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.key_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.key_points:
        _x = val1
        buff.write(_struct_5fi.pack(_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign))
        length = len(val1.feature_vector)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.feature_vector.tostring())
        length = len(val1.vector_limits)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(val1.vector_limits.tostring())
      length = len(self.match_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.match_results:
        _x = val1.object_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.object_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v9 = val1.image
        _v10 = _v9.header
        buff.write(_struct_I.pack(_v10.seq))
        _v11 = _v10.stamp
        _x = _v11
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v10.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v9
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v9.encoding
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v9
        buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
        _x = _v9.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.image_index))
        _x = val1.image_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.outline)
        buff.write(_struct_I.pack(length))
        for val2 in val1.outline:
          _x = val2
          buff.write(_struct_2d.pack(_x.x, _x.y))
        length = len(val1.b_box)
        buff.write(_struct_I.pack(length))
        for val2 in val1.b_box:
          _x = val2
          buff.write(_struct_2d.pack(_x.x, _x.y))
        _v12 = val1.center
        _x = _v12
        buff.write(_struct_2d.pack(_x.x, _x.y))
        buff.write(_struct_i.pack(val1.bounding_box_index))
        length = len(val1.key_point_index_map)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(val1.key_point_index_map.tostring())
        length = len(val1.object_key_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.object_key_points:
          _x = val2
          buff.write(_struct_5fi.pack(_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign))
          length = len(val2.feature_vector)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(val2.feature_vector.tostring())
          length = len(val2.vector_limits)
          buff.write(_struct_I.pack(length))
          pattern = '<%sI'%length
          buff.write(val2.vector_limits.tostring())
        length = len(val1.stage1_matchesb_)
        buff.write(_struct_I.pack(length))
        for val2 in val1.stage1_matchesb_:
          _x = val2
          buff.write(_struct_2I3d.pack(_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient))
        length = len(val1.stage2_matches)
        buff.write(_struct_I.pack(length))
        for val2 in val1.stage2_matches:
          length = len(val2.key_point_match_array)
          buff.write(_struct_I.pack(length))
          for val3 in val2.key_point_match_array:
            _x = val3
            buff.write(_struct_2I3d.pack(_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient))
        length = len(val1.stage3_matches)
        buff.write(_struct_I.pack(length))
        for val2 in val1.stage3_matches:
          _x = val2
          buff.write(_struct_2I3d.pack(_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient))
        length = len(val1.scene_key_points_within_outline)
        buff.write(_struct_I.pack(length))
        for val2 in val1.scene_key_points_within_outline:
          _x = val2
          buff.write(_struct_5fi.pack(_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign))
          length = len(val2.feature_vector)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(val2.feature_vector.tostring())
          length = len(val2.vector_limits)
          buff.write(_struct_I.pack(length))
          pattern = '<%sI'%length
          buff.write(val2.vector_limits.tostring())
        buff.write(val1.homography.tostring())
      length = len(self.bounding_boxes)
      buff.write(_struct_I.pack(length))
      for val1 in self.bounding_boxes:
        _x = val1
        buff.write(_struct_4f.pack(_x.minX, _x.minY, _x.maxX, _x.maxY))
      _x = self
      buff.write(_struct_i3I.pack(_x.seq_num, _x.debug_image_with_bb.header.seq, _x.debug_image_with_bb.header.stamp.secs, _x.debug_image_with_bb.header.stamp.nsecs))
      _x = self.debug_image_with_bb.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.debug_image_with_bb.height, _x.debug_image_with_bb.width))
      _x = self.debug_image_with_bb.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.debug_image_with_bb.is_bigendian, _x.debug_image_with_bb.step))
      _x = self.debug_image_with_bb.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.image is None:
        self.image = sensor_msgs.msg.Image()
      if self.key_points is None:
        self.key_points = None
      if self.match_results is None:
        self.match_results = None
      if self.bounding_boxes is None:
        self.bounding_boxes = None
      if self.debug_image_with_bb is None:
        self.debug_image_with_bb = sensor_msgs.msg.Image()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.image.header.seq, _x.image.header.stamp.secs, _x.image.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.image.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.image.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.image.height, _x.image.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.image.encoding = str[start:end].decode('utf-8')
      else:
        self.image.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.image.is_bigendian, _x.image.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.image.data = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.key_points = []
      for i in range(0, length):
        val1 = or_msgs.msg.KeyPoint()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign,) = _struct_5fi.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.feature_vector = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        val1.vector_limits = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        self.key_points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.match_results = []
      for i in range(0, length):
        val1 = or_msgs.msg.MatchResult()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.object_name = str[start:end].decode('utf-8')
        else:
          val1.object_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.object_type = str[start:end].decode('utf-8')
        else:
          val1.object_type = str[start:end]
        _v13 = val1.image
        _v14 = _v13.header
        start = end
        end += 4
        (_v14.seq,) = _struct_I.unpack(str[start:end])
        _v15 = _v14.stamp
        _x = _v15
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v14.frame_id = str[start:end].decode('utf-8')
        else:
          _v14.frame_id = str[start:end]
        _x = _v13
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v13.encoding = str[start:end].decode('utf-8')
        else:
          _v13.encoding = str[start:end]
        _x = _v13
        start = end
        end += 5
        (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v13.data = str[start:end]
        start = end
        end += 4
        (val1.image_index,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.image_name = str[start:end].decode('utf-8')
        else:
          val1.image_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.outline = []
        for i in range(0, length):
          val2 = or_msgs.msg.Point2D()
          _x = val2
          start = end
          end += 16
          (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
          val1.outline.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.b_box = []
        for i in range(0, length):
          val2 = or_msgs.msg.Point2D()
          _x = val2
          start = end
          end += 16
          (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
          val1.b_box.append(val2)
        _v16 = val1.center
        _x = _v16
        start = end
        end += 16
        (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
        start = end
        end += 4
        (val1.bounding_box_index,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        val1.key_point_index_map = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.object_key_points = []
        for i in range(0, length):
          val2 = or_msgs.msg.KeyPoint()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign,) = _struct_5fi.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val2.feature_vector = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sI'%length
          start = end
          end += struct.calcsize(pattern)
          val2.vector_limits = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
          val1.object_key_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.stage1_matchesb_ = []
        for i in range(0, length):
          val2 = or_msgs.msg.KeyPointMatch()
          _x = val2
          start = end
          end += 32
          (_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient,) = _struct_2I3d.unpack(str[start:end])
          val1.stage1_matchesb_.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.stage2_matches = []
        for i in range(0, length):
          val2 = or_msgs.msg.KeyPointMatchArray()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.key_point_match_array = []
          for i in range(0, length):
            val3 = or_msgs.msg.KeyPointMatch()
            _x = val3
            start = end
            end += 32
            (_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient,) = _struct_2I3d.unpack(str[start:end])
            val2.key_point_match_array.append(val3)
          val1.stage2_matches.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.stage3_matches = []
        for i in range(0, length):
          val2 = or_msgs.msg.KeyPointMatch()
          _x = val2
          start = end
          end += 32
          (_x.index1, _x.index2, _x.distance, _x.turn_angle, _x.scale_quotient,) = _struct_2I3d.unpack(str[start:end])
          val1.stage3_matches.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.scene_key_points_within_outline = []
        for i in range(0, length):
          val2 = or_msgs.msg.KeyPoint()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.scale, _x.strength, _x.orientation, _x.sign,) = _struct_5fi.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val2.feature_vector = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sI'%length
          start = end
          end += struct.calcsize(pattern)
          val2.vector_limits = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
          val1.scene_key_points_within_outline.append(val2)
        start = end
        end += 72
        val1.homography = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
        self.match_results.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bounding_boxes = []
      for i in range(0, length):
        val1 = or_msgs.msg.BoundingBox2D()
        _x = val1
        start = end
        end += 16
        (_x.minX, _x.minY, _x.maxX, _x.maxY,) = _struct_4f.unpack(str[start:end])
        self.bounding_boxes.append(val1)
      _x = self
      start = end
      end += 16
      (_x.seq_num, _x.debug_image_with_bb.header.seq, _x.debug_image_with_bb.header.stamp.secs, _x.debug_image_with_bb.header.stamp.nsecs,) = _struct_i3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.debug_image_with_bb.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.debug_image_with_bb.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.debug_image_with_bb.height, _x.debug_image_with_bb.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.debug_image_with_bb.encoding = str[start:end].decode('utf-8')
      else:
        self.debug_image_with_bb.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.debug_image_with_bb.is_bigendian, _x.debug_image_with_bb.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.debug_image_with_bb.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_5fi = struct.Struct("<5fi")
_struct_2I3d = struct.Struct("<2I3d")
_struct_BI = struct.Struct("<BI")
_struct_9d = struct.Struct("<9d")
_struct_2d = struct.Struct("<2d")
_struct_i = struct.Struct("<i")
_struct_3I = struct.Struct("<3I")
_struct_4f = struct.Struct("<4f")
_struct_i3I = struct.Struct("<i3I")
_struct_2I = struct.Struct("<2I")
